/*
  ____   __   __     _      ____   __   __  _   _   ____    _   _   _  __     _    
 |  _ \  \ \ / /    / \    |  _ \  \ \ / / | | | | / ___|  | | | | | |/ /    / \   
 | | | |  \ V /    / _ \   | | | |  \ V /  | | | | \___ \  | |_| | | ' /    / _ \  
 | |_| |   | |    / ___ \  | |_| |   | |   | |_| |  ___) | |  _  | | . \   / ___ \ 
 |____/    |_|   /_/   \_\ |____/    |_|    \___/  |____/  |_| |_| |_|\_\ /_/   \_\
                                                                                   
  ____   __   __     _      ____   __   __     _    
 |  _ \  \ \ / /    / \    |  _ \  \ \ / /    / \   
 | | | |  \ V /    / _ \   | | | |  \ V /    / _ \  
 | |_| |   | |    / ___ \  | |_| |   | |    / ___ \ 
 |____/    |_|   /_/   \_\ |____/    |_|   /_/   \_\
                                                    
  _____   ____    ___   _____   _____   ____  
 | ____| |  _ \  |_ _| |_   _| | ____| |  _ \ 
 |  _|   | | | |  | |    | |   |  _|   | | | |
 | |___  | |_| |  | |    | |   | |___  | |_| |
 |_____| |____/  |___|   |_|   |_____| |____/ 
                                              
*/
using UnityEngine;
using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using UnityEngine.Events;
using TMPro;
using UnityEngine.SceneManagement;
using System.Linq;
using UnityEngine.UI;

namespace Mod
{
	public class Mod : MonoBehaviour
	{
		public static Map[] Maps;
		public static Map Vol;
		public static Sprite TemplateSprite = ModAPI.LoadSprite("TEMPLATE.png");
		public static string mapname;
		public static MapSelectionMenuBehaviour mapmenu = UnityEngine.Object.FindObjectOfType<MapSelectionMenuBehaviour>();
		public static bool debounce = false;
		public static Sprite Square = ModAPI.LoadSprite("black.png");
		public static Sprite Lava = ModAPI.LoadSprite("Lava.png");
		public static Sprite Acid = ModAPI.LoadSprite("Acid.png");
		public static AudioClip acidhiss = ModAPI.LoadSound("Hiss.wav");
		public static bool Done = false;
		public static string MapModName = "";
		public static string MapName = "SubHybrid";
		

		public static PhysicalProperties phys = ModAPI.FindPhysicalProperties("Soft");

		public static void OnLoad()
		{
			phys.Brittleness = 0f;
			phys.Buoyancy = 0f;
			phys.Flammability = 0f;
			phys.MagneticAttractionIntensity = 0f;
			phys.Conducting = false;
			phys.Burnrate = 0f;
			phys.ImpactIntensityMutliplier = 1f;
			phys.HitVolumeMultiplier = 1f;
			phys.BulletSpeedAbsorptionPower = 0f;
			phys.Softness = 0.1f;
			phys.LodgeStrengthMultiplier = 0.1f;
			phys.SharpForceThresholdMultiplier = 1f;
			// 
			Map MapMod = ScriptableObject.CreateInstance<Map>();
			MapMod.name = MapName;
			MapMod.UniqueIdentity = Guid.NewGuid().ToString();
			MapMod.Description = "Map";
			MapMod.Thumbnail = ModAPI.LoadSprite("TEMPLATE.png");
			MapMod.Preview = ModAPI.LoadSprite("TEMPLATE.png");
			MapMod.Prefab = MapRegistry.GetAllMaps().ElementAt(2).Prefab;
			MapModName = MapMod.name;
			MapRegistry.Register(MapMod);
		}

		public static void RemoveBorders()
		{
			foreach (var render in GameObject.Find("Root").transform.parent.GetComponentsInChildren<SpriteRenderer>())
			{
				if (render.gameObject.layer == LayerMask.NameToLayer("Bounds") && render.gameObject.GetComponent<Undraggable>())
				{
					Destroy(render.gameObject);
				}
			}

			Map eggs = Resources.Load<Map>("Maps/Humongous");
			foreach (MapLightBehaviour light in UnityEngine.Object.FindObjectsOfType<MapLightBehaviour>())
			{
				Destroy(light.gameObject);
			}
			var thing = Instantiate<GameObject>(eggs.Prefab.transform.Find("Lightbulb/BulbGlow/full ambient").gameObject);
			thing.transform.position = new Vector2(500f, 100f);
			thing.transform.localScale = new Vector2(100000f, 100000f);
			thing.GetComponent<SpriteRenderer>().material.SetFloat("_GlowIntensity", 1.2f);
			thing.GetComponent<SpriteRenderer>().material.SetColor("_GlowColour", new Color32(255, 255, 255, 225));
			if (GameObject.Find("Panels"))
			{
				GameObject.Find("Panels").transform.localScale = new Vector2(100000f, 100000f);
			}
			MapConfig mapconfig = UnityEngine.Object.FindObjectOfType<MapConfig>();
			mapconfig.GetComponent<BoundingBoxBehaviour>().BoundingBox = new Bounds(new Vector3(500f, 250f, 0f), new Vector3(1500000f, 1500000f, 0f));
		}

		public static void CreateGameObjects(string Name, Vector2 Pos, Vector2 Size, Quaternion Rotation, string Layer, bool NoCollision, int Order = 0)
		{
			var NewGameobject = ModAPI.CreatePhysicalObject(Name, Mod.Square);
			NewGameobject.tag = "NoClear";
			NewGameobject.layer = LayerMask.NameToLayer("Bounds");
			NewGameobject.transform.localScale = Size;
			NewGameobject.transform.position = Pos;
			if (Layer == "Front")
			{
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Top");
			}
			if (Layer == "Back")
			{
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Background");
			}
			NewGameobject.transform.rotation = Rotation;
			if (NoCollision)
			{
				NewGameobject.GetComponent<Collider2D>().enabled = false;
			}
			NewGameobject.transform.parent = null;
			NewGameobject.GetComponent<SpriteRenderer>().sortingOrder = Order;
			NewGameobject.AddComponent<Undraggable>();
			NewGameobject.GetComponent<Rigidbody2D>().constraints = RigidbodyConstraints2D.FreezeAll;
			NewGameobject.AddComponent<ContextMenuOptionComponent>();
			PhysicalBehaviour physicalBehaviour = NewGameobject.GetComponent<PhysicalBehaviour>();
			physicalBehaviour.Properties = Mod.phys;
			physicalBehaviour.SpawnSpawnParticles = false;
			physicalBehaviour.OverrideShotSounds = new AudioClip[0];
			physicalBehaviour.OverrideImpactSounds = new AudioClip[0];
			physicalBehaviour.Deletable = false;
			physicalBehaviour.Disintegratable = false;
			///NewGameobject.AddComponent<AudioSource>();
			///NewGameobject.AddComponent<AudioSourceTimeScaleBehaviour>();
			NewGameobject.AddComponent<TestDelay>();
		}

		public static void CreateCustomGameObjects(string Name, Vector2 Pos, Vector2 Size, Quaternion Rotation, Sprite spritey, string Layer, bool NoCollision, int Order = 0)
		{
			var NewGameobject = ModAPI.CreatePhysicalObject(Name, spritey);
			NewGameobject.tag = "NoClear";
			NewGameobject.layer = LayerMask.NameToLayer("Bounds");
			NewGameobject.transform.position = Pos;
			NewGameobject.transform.localScale = Size;
			NewGameobject.transform.rotation = Rotation;
			NewGameobject.FixColliders();
			if (Layer == "Front")
			{
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Top");
			}
			if (Layer == "Back")
			{
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Background");
			}
			if (NoCollision)
			{
				foreach (var col in NewGameobject.GetComponents<Collider2D>())
				{
					col.enabled = false;
				}
			}
			NewGameobject.transform.parent = null;
			NewGameobject.GetComponent<SpriteRenderer>().sortingOrder = Order;
			NewGameobject.GetComponent<Rigidbody2D>().constraints = RigidbodyConstraints2D.FreezeAll;
			NewGameobject.AddComponent<Undraggable>();
			NewGameobject.AddComponent<ContextMenuOptionComponent>();
			PhysicalBehaviour physicalBehaviour = NewGameobject.GetComponent<PhysicalBehaviour>();
			physicalBehaviour.Properties = Mod.phys;
			physicalBehaviour.SpawnSpawnParticles = false;
			physicalBehaviour.OverrideShotSounds = new AudioClip[0];
			physicalBehaviour.OverrideImpactSounds = new AudioClip[0];
			physicalBehaviour.Deletable = false;
			physicalBehaviour.Disintegratable = false;
			physicalBehaviour.rigidbody = NewGameobject.GetComponent<Rigidbody2D>();
			///NewGameobject.AddComponent<AudioSource>();
			///NewGameobject.AddComponent<AudioSourceTimeScaleBehaviour>();
			NewGameobject.AddComponent<TestDelay>();
		}

		public static void CreateSpawnable(string Name, Vector2 Pos, Vector2 Size, Quaternion Rotation, bool FacingRight, bool Frozen)
		{
			GameObject NewGameobject = Instantiate<GameObject>(ModAPI.FindSpawnable(Name).Prefab, Vector3.zero, Quaternion.identity);
			NewGameobject.transform.position = Pos;
			NewGameobject.transform.localScale = Size;
			NewGameobject.transform.rotation = Rotation;
			if (!FacingRight)
			{
				NewGameobject.transform.localScale = new Vector2(-NewGameobject.transform.localScale.x, NewGameobject.transform.localScale.y);
			}
			if (Frozen)
			{
				NewGameobject.AddComponent<TestDelay>();
			}
		}

		public static void CreatePhysicsGameObjects(string Name, Vector2 Pos, Vector2 Size, Quaternion Rotation, Sprite spritey, string Layer, bool NoCollision)
		{
			var NewGameobject = ModAPI.CreatePhysicalObject(Name, spritey);
			if (Layer == "Front")
			{
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Objects");
			}
			if (Layer == "Back")
			{
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Background");
			}
			NewGameobject.tag = "NoClear";
			NewGameobject.transform.position = Pos;
			NewGameobject.transform.localScale = Size;
			NewGameobject.transform.rotation = Rotation;
			NewGameobject.FixColliders();
			PhysicalBehaviour physicalBehaviour = NewGameobject.GetComponent<PhysicalBehaviour>();
			if (NoCollision)
			{
				NewGameobject.GetComponent<Collider2D>().enabled = false;
			}
			physicalBehaviour.OverrideShotSounds = new AudioClip[0];
			physicalBehaviour.OverrideImpactSounds = new AudioClip[0];
		}

		public static void CreateLightSources(String Name, Vector2 Pos, Vector2 Size, Quaternion Rotation, Color32 color, float brightness)
		{
			var NewGameobject = new GameObject();
			NewGameobject.tag = "NoClear";
			NewGameobject.transform.position = Pos;
			NewGameobject.transform.localScale = Size;
			NewGameobject.transform.rotation = Rotation;
			var light = ModAPI.CreateLight(NewGameobject.transform, color, brightness);
			light.gameObject.tag = "NoClear";
		}

		public static void CreateBackground(String Name, Color32 color, Sprite spritey, bool IsTexture)
		{
			var NewGameobject = new GameObject();
			NewGameobject.tag = "NoClear";
			NewGameobject.transform.position = new Vector2(572.314f, 496.2918f);
			var whitespace = Texture2D.whiteTexture;
			whitespace.Resize(16, 16);
			whitespace.Apply();
			if (IsTexture == true)
			{
				var croppedTexture = new Texture2D((int)spritey.rect.width, (int)spritey.rect.height);
				var pixels = spritey.texture.GetPixels((int)spritey.textureRect.x,
														(int)spritey.textureRect.y,
														(int)spritey.textureRect.width,
														(int)spritey.textureRect.height);
				croppedTexture.SetPixels(pixels);
				croppedTexture.wrapMode = TextureWrapMode.Repeat;
				croppedTexture.filterMode = FilterMode.Point;
				croppedTexture.Apply();
				var copy = Sprite.Create(croppedTexture, new Rect(0f, 0f, (float)croppedTexture.width, (float)croppedTexture.height), 0.5f * Vector2.one, 140f, 0, SpriteMeshType.FullRect);
				NewGameobject.AddComponent<SpriteRenderer>().drawMode = SpriteDrawMode.Tiled;
				NewGameobject.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("Sprites-Default");
				NewGameobject.GetComponent<SpriteRenderer>().sprite = copy;
				NewGameobject.GetComponent<SpriteRenderer>().size = new Vector2(5, 5);
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Bottom");
				///NewGameobject.GetComponent<SpriteRenderer>().sortingOrder = 25;
			}
			else
			{
				NewGameobject.AddComponent<SpriteRenderer>().sprite = Sprite.Create(whitespace, new Rect(0f, 0f, 16f, 16f), 0.5f * Vector2.one, 35f);
				NewGameobject.GetComponent<SpriteRenderer>().color = color;
				NewGameobject.GetComponent<SpriteRenderer>().sortingLayerID = SortingLayer.NameToID("Bottom");
				///NewGameobject.GetComponent<SpriteRenderer>().sortingOrder = 25;
			}
			NewGameobject.transform.localScale = new Vector2(2533.112f, 2175.462f);
			NewGameobject.transform.parent = null;
			NewGameobject.layer = LayerMask.NameToLayer("Bounds");
		}

		public static void CreateParticleSources(string Name, Vector2 Pos, float Speed, string Particles)
		{
			var NewGameobject = new GameObject();
			NewGameobject.tag = "NoClear";
			NewGameobject.name = Name;
			NewGameobject.transform.position = Pos;
			NewGameobject.AddComponent<ParticleDelay>();
			NewGameobject.GetComponent<ParticleDelay>().Speed1 = Speed;
			NewGameobject.GetComponent<ParticleDelay>().Particles1 = Particles;
		}

		public static void AddAudioToAmbience(float Bacon, AudioClip[] Eggs)
		{
			///Changing this to other variables in the MapConfig will let you force snow on and other stuff.
			MapConfig mapconfig = UnityEngine.Object.FindObjectOfType<MapConfig>();
			///mapconfig.OverrideAmbientSounds = true;
			var hhh = mapconfig.transform.parent.GetComponent<PlayAudioAtRandom>();
			hhh.Clips = Eggs;
			hhh.ChancePerSecond = Bacon;
		}

		public static void CreateWaterBlock(Vector3 Size, Vector3 Pos, Quaternion Rotation, string Type)
		{
			switch (Type)
			{
				case "Water":
					{
						Map sea = Resources.Load<Map>("Maps/Sea");
						GameObject WaterBefore = sea.Prefab.transform.Find("Root/Sea").gameObject;
						var Water = Instantiate<GameObject>(WaterBefore, Vector3.zero, Quaternion.identity);
						Water.transform.rotation = Rotation;
						Water.transform.localScale = new Vector2(Size.x, -Size.y);
						Water.transform.localPosition = Pos;
						break;
					}
				case "Acid":
					{
						Map sea = Resources.Load<Map>("Maps/Sea");
						GameObject WaterBefore = sea.Prefab.transform.Find("Root/Sea").gameObject;
						var Water = Instantiate<GameObject>(WaterBefore, Vector3.zero, Quaternion.identity);
						Water.transform.rotation = Rotation;
						Water.transform.localScale = new Vector2(Size.x, -Size.y);
						Water.transform.localPosition = Pos;
						Water.name = "Acid";
						Water.AddComponent<AcidWater>();
						break;
					}
				case "Lava":
					{
						Map lavaMap = Resources.Load<Map>("Maps/Lava");
						GameObject LavaBefore = lavaMap.Prefab.transform.Find("Lava pool").gameObject;
						var Lava = Instantiate<GameObject>(LavaBefore, Vector3.zero, Quaternion.identity);
						Lava.transform.rotation = Rotation;
						Lava.transform.localScale = new Vector2(Size.x, -Size.y);
						Lava.transform.localPosition = Pos;
						break;
					}
			}
		}

		public static void Main()
		{
			///Don't do anything yet.
			if (MapLoaderBehaviour.CurrentMap.name == MapModName)
			{
				Debug.Log("Setting up some stuff.");
				var manager = new GameObject("managerMap");
				manager.AddComponent<MapModManager>();
			}
		}
		public static void InitilizeMap()
		{
			foreach (var waterBlock in GameObject.FindObjectsOfType<WaterBehaviour>())
			{
				GameObject.Destroy(waterBlock.gameObject);
			}
			foreach (var waterBlock in GameObject.FindObjectsOfType<LavaBehaviour>())
			{
				GameObject.Destroy(waterBlock.gameObject);
			}
			
			CreateGameObjects("Other", new Vector2(745.4298f, 115.8142f), new Vector2(-29258f, 8144.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(63.37889f, 25.14859f), new Vector2(-2358f, 2142f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(63.3789f, 85.13141f), new Vector2(-2358f, 2142f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(126.38f, 21.24924f), new Vector2(-2358f, 2142f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(150.9707f, 121.4094f), new Vector2(-3558f, 2342f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(168.1599f, 65.53392f), new Vector2(-2358f, 2142f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateWaterBlock(new Vector3(-37.8f, 16.2f, 1f), new Vector3(115.6308f, 59.7741f, 0f), Quaternion.Euler(0f, 0f, 0f), "Acid");
                CreateGameObjects("Other", new Vector2(150.7412f, 201.0952f), new Vector2(-3558f, 2214f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateLightSources("Light", new Vector2(115.9371f, 60.63755f), new Vector2(-37.5f, 21f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255, 255, 255), 1f);
                CreateGameObjects("Other", new Vector2(251.881f, 201.0786f), new Vector2(-3558f, 2214f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(277.2308f, 79.07298f), new Vector2(-3558f, 2214f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(49.32794f, 200.9222f), new Vector2(-3558f, 2214f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(10.7916f, 200.9562f), new Vector2(-3235.5f, 2214f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(98.40279f, 139.3946f), new Vector2(135.5f, 1084f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateWaterBlock(new Vector3(-39.3f, 136.2f, 1f), new Vector3(12.69629f, 38.343f, 0f), Quaternion.Euler(0f, 0f, 0f), "Water");
                CreateGameObjects("Other", new Vector2(200.3695f, 3.556449f), new Vector2(42f, 339.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateWaterBlock(new Vector3(-39.8f, 7.7f, 1f), new Vector3(179.944f, 3.40345f, 0f), Quaternion.Euler(0f, 0f, 0f), "Lava");
                CreateWaterBlock(new Vector3(-5.3f, 16.2f, 1f), new Vector3(230.9462f, 14.72427f, 0f), Quaternion.Euler(0f, 0f, 0f), "Water");
                CreateWaterBlock(new Vector3(-5.3f, 16.2f, 1f), new Vector3(238.1708f, 14.72697f, 0f), Quaternion.Euler(0f, 0f, 0f), "Acid");
                CreateWaterBlock(new Vector3(-5.3f, 16.2f, 1f), new Vector3(245.3795f, 14.7248f, 0f), Quaternion.Euler(0f, 0f, 0f), "Lava");
                CreateGameObjects("Other", new Vector2(234.5419f, 15.60153f), new Vector2(67.5f, 628.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(241.7819f, 15.60373f), new Vector2(67.5f, 628.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(227.3411f, 15.59088f), new Vector2(67.5f, 628.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(249.0101f, 15.59719f), new Vector2(67.5f, 628.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(238.1776f, 23.9865f), new Vector2(824.6999f, 42f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(249.0267f, 5.184363f), new Vector2(67.5f, 402f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateWaterBlock(new Vector3(-31.3f, 1.2f, 1f), new Vector3(215.536f, 0.2370769f, 0f), Quaternion.Euler(0f, 0f, 0f), "Water");
                CreateGameObjects("Other", new Vector2(238.07f, 25.46247f), new Vector2(1212f, 107f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(238.453f, 38.7905f), new Vector2(1212f, 107f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(238.5259f, 48.96519f), new Vector2(1212f, 107f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(267.2092f, 13.22449f), new Vector2(1212f, 962f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(275.2433f, 40.41729f), new Vector2(642f, 557f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateLightSources("Light", new Vector2(306.5466f, 23.04511f), new Vector2(-31.20008f, 33.90005f), Quaternion.Euler(0f, 0f, 0f), new Color32(255, 255, 255, 255), 1f);
                CreateWaterBlock(new Vector3(43.49991f, 48.89983f, 1f), new Vector3(306.24f, 23.47854f, 0f), Quaternion.Euler(0f, 0f, 0f), "Acid");
                CreateGameObjects("Other", new Vector2(238.461f, 60.19061f), new Vector2(1212f, 107f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(238.5882f, 71.50658f), new Vector2(1212f, 107f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(237.6982f, 82.56827f), new Vector2(1212f, 107f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(201.0986f, 93.5479f), new Vector2(1212f, 107f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(237.4263f, 1.55699f), new Vector2(771f, 165.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(838.0734f, 610.2726f), new Vector2(-21910.26f, 27964.5f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(323.6435f, 115.5888f), new Vector2(353f, 373f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(315.1828f, 112.6119f), new Vector2(353f, 373f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(305.8995f, 109.7917f), new Vector2(353f, 373f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(296.6229f, 107.6742f), new Vector2(353f, 373f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                CreateGameObjects("Other", new Vector2(286.8452f, 106.3792f), new Vector2(353f, 373f), Quaternion.Euler(0f, 0f, 0f), "Front", false, 0);
                
		}
	}
	public class AcidWater : MonoBehaviour
	{
		private void Start()
		{
			SpriteRenderer spriteRenderer = gameObject.GetComponent<SpriteRenderer>();
			spriteRenderer.material.shader = Shader.Find("Sprites/Default");
			spriteRenderer.material.color = new Color(0, 1f, 0.1509f, 0.1819f);
			spriteRenderer.color = new Color(0, 1, 0, 1);
		}
		private void OnTriggerEnter2D(Collider2D collider2D)
		{
			if (collider2D.gameObject.GetComponent<LimbBehaviour>() != null)
			{
				collider2D.gameObject.AddComponent<AcidEffect>();
			}
		}
		private void OnTriggerExit2D(Collider2D collider2D)
		{
			if (collider2D.gameObject.GetComponent<AcidEffect>() != null)
			{
				UnityEngine.Object.Destroy(collider2D.gameObject.GetComponent<AcidEffect>());
			}
		}

	}
	public class AcidEffect : MonoBehaviour
	{
		LimbBehaviour limbBehaviour;
		private void Start()
		{
			limbBehaviour = gameObject.GetComponent<LimbBehaviour>();
		}
		private void Update()
		{
			limbBehaviour.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("ACID"), 0.05f * Time.deltaTime);
		}
	}
	public class MapModManager : MonoBehaviour
	{
		private void Start()
		{
			Mod.InitilizeMap();
		}
	}

	public class TestDelay : MonoBehaviour
	{
		public void Awake()
		{
			StartCoroutine(Delay());
		}

		public IEnumerator Delay()
		{
			yield return new WaitForSeconds(0f);
			foreach (var Rig in this.gameObject.GetComponentsInChildren<Rigidbody2D>())
			{
				Rig.bodyType = RigidbodyType2D.Static;
			}
		}
	}

	public class ParticleDelay : MonoBehaviour
	{
		public string Particles1;
		public float Speed1;
		public void Awake()
		{
			StartCoroutine(Emit());
		}

		public IEnumerator Emit()
		{
			yield return new WaitForSeconds(0.25f);
			while (true)
			{
				var time = 1f / Speed1;
				ModAPI.CreateParticleEffect(Particles1.ToString(), gameObject.transform.position);
				yield return new WaitForSeconds(time);
			}
		}
	}
}

